/* Function searchengineorder()
 * Starts Search Engine Ordering in a ew window or tab.
 * Startet Search Engine Ordering in einem neuen Fenster oder Tab, je nachdem, was der Benutzer eingestellt hat.
 */
function searchengineordering()
{
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    var url = "chrome://searchengineordering/content/order.xul";
    if(prefs.getPrefType("extensions.searchengineordering.openintab") === prefs.PREF_BOOL)
    {
        try
        {
            if(prefs.getBoolPref("extensions.searchengineordering.openintab") !== false)
	        {
                SEO_openAndReuseOneTabPerURL(url);
	            return true;
            }
	    }
	    catch(e)
	    {
	        prefs.setBoolPref("extensions.searchengineordering.openintab","false")
	    }
    }
    window.open(url,"searchengineordering-options","chrome,resizable=1");
    return true;
}

//this function is originally from the MozillaZine Knowledge Base: http://kb.mozillazine.org/Reusing_tabs_for_the_same_URL
function SEO_openAndReuseOneTabPerURL(url) {
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
  var browserEnumerator = wm.getEnumerator("navigator:browser");

  // Check each browser instance for our URL
  var found = false;
  while (browserEnumerator.hasMoreElements() && !found) {
    var browserInstance = browserEnumerator.getNext();
    browserInstance = browserInstance.getBrowser();

    // Check each tab of this browser instance
    var index = 0, numTabs = browserInstance.mPanelContainer.childNodes.length;
    while (index < numTabs && !found) {
      var currentTab = browserInstance.getBrowserAtIndex(index);
      if (url == currentTab.currentURI.spec) {
        // The URL is already opened. Select its tab.
        browserInstance.selectedTab = currentTab;
        // Focus *this* browser
        browserInstance.focus();
        found = true;
      }
      index++;
    }
  }

  // Our URL isn't open. Open it now.
  if (!found) {
    var recentWindow = wm.getMostRecentWindow("navigator:browser");
    if (recentWindow) {
      // Use an existing browser window
      recentWindow.delayedOpenTab(url);
    }
    else {
      // No browser windows are open, so open a new one.
      window.open(url);
    }
  }
}